      SUBROUTINE CEM (M,N,C,XI,E,Y,AL,SUM,B,IN)                         00010000
CCC       PROLATE RADIAL FUNCTION OF SECOND KIND IN NEUMANN SERIES BY   00020000
CCC       THE INTEGRAL METHOD OF SINHA & MACPHIE (1975)                 00030000
CCC       C = COMPLEX    :    CALCULATION - COMPLEX*16                  00040000
CCC       REQUIRED SUBPROGRAMS : CFCT, DGAUSL                           00050000
CCC
      IMPLICIT COMPLEX*16 (A-H,O-Z)                                     00060000
      REAL*8 AL,XI,Y1,Y2,B,CF,CFCT,DGAUSL                               00070000
      EXTERNAL  CFCT                                                    00080000
      COMMON  /R2INTC/D(6),CF,MMM,NNN,IST                               00090000
      DIMENSION H(6),G(6),F(6),BT(6)                                    00100000
      MMM=M                                                             00110000
      NNN=N                                                             00120000
      HH=(4*M*M-1)*C*C                                                  00130003
      MM=M*M                                                            00140000
      U=4*E-2*C*C                                                       00150000
      F(1)=2.*(M-1)                                                     00160000
      F(2)=(U+(4*MM-28.*M+24.))/4.                                      00170000
      F(3)=((4*M-14.)*U-(40*MM-184*M+144.))/8.                          00180000
      F(4)=(U*U+(4*MM-68.*M+140.)*U+2.*HH+(304*MM-1168.*M+864))/16.     00190000
      F(5)=((4*M-24)*U*U-(80*MM-768.*M+1208.)*U+(8*M-48.)*HH-(2080*MM   00200000
     + -7264*M+5184.))/32.                                              00210003
      F(6)=(U**3+(4*MM-108.*M+356.)*U*U+(1008*MM-7216.*M+9584)*U        00220000
     + +4.*U*HH+(8*MM-216.*M+718)*HH+(13504*MM-44608*M+31104))/64.      00230003
      W=C*C*XI*XI/2.                                                    00240000
      WW= W*W                                                           00250000
         IF (IN.EQ.1)  THEN                                             00260000
      G(1)=2.                                                           00270000
      G(2)=-W-2.                                                        00280000
      G(3)=3*W+2                                                        00290000
      G(4)=-(WW+19*W+8.)/4.                                             00300000
      G(5)=(24*WW+56*W+16.)/8.                                          00310000
      G(6)=-(4*W**3+62*WW+153*W+32.)/16.                                00320000
         ELSE                                                           00330004
      G(1)=0.                                                           00340004
      G(2)=-W                                                           00350004
      G(3)=W                                                            00360004
      G(4)=-(WW+7*W)/4.                                                 00370005
      G(5)=-(4*WW-20*W)/8.                                              00380005
      G(6)=-(4*WW*W+14*WW+61*W)/16.                                     00390005
         END IF                                                         00400004
    7 CONTINUE                                                          00410000
      AL=DLOG(XI)                                                       00420000
      DO 12 I=1,6                                                       00430000
      H(I)=F(I)+G(I)                                                    00440000
      I1=I-1                                                            00450000
      IF (I1.EQ.0) GO TO 12                                             00460000
      DO 10 L=1,I1                                                      00470000
      H(I)=H(I)+F(L)*G(I-L)                                             00480000
   10 CONTINUE                                                          00490000
   12 CONTINUE                                                          00500000
      B=H(1)/2.                                                         00510000
      BT(1)=B*(B-1)                                                     00520000
      DO 20 I=2,5                                                       00530000
      BT(I)=BT(I-1)*(B-I)                                               00540000
   20 CONTINUE                                                          00550000
      D(1)=(2*BT(1)-H(2))/2.                                            00560000
       D11= D(1)*D(1)                                                   00570005
      D(2)=(4*BT(2)/3.-4*B*D(1)+4*D(1)-H(3))/4.                         00580000
       D22= D(2)*D(2)                                                   00590005
      D(3)=(2*BT(3)/3.-4*BT(1)*D(1)+8*B*(D(1)-D(2))-(8*D(1)-2*D11-12    00600005
     + *D(2))-H(4))/6.                                                  00610003
      D(4)=(4*BT(4)/15.-8*BT(2)*D(1)/3.+8*BT(1)*(D(1)-D(2))-2*B*(8*D(1) 00620000
     + -2*D11-12*D(2)+6*D(3))+                                          00630005
     + (16*D(1)-8*D11+8*D(1)*D(2)-32*D(2)+24*D(3))-H(5))/8.             00640005
      D(5)=(4*BT(5)/45.-4*BT(3)*D(1)/3.+16*BT(2)/3.*(D(1)-D(2))         00650000
     1 -2*BT(1)*(8*D(1)-2*D11-12*D(2)+6*D(3))                           00660000
     2 +2*B*(16*D(1)-8*D11+8*D(1)*D(2)-32*D(2)+24*D(3)-8*D(4))          00670000
     3 -(32*D(1)-24*D11+40*D(1)*D(2)-80*D(2)-8*D22                      00680005
     4 -12*D(1)*D(3)+80*D(3)-40*D(4)+4.*D11/3.)-H(6))/10.               00690005
      SUM=0.                                                            00700000
      DO 15 K=1,5                                                       00710000
      SUM=SUM+D(K)/(M+N)**K                                             00720000
   15 CONTINUE                                                          00730000
      CF=AL                                                             00740000
      D(6)=B                                                            00750000
      IST=1                                                             00760000
       Y1=DGAUSL(CFCT,5)                                                00770005
      IST=-1                                                            00780000
       Y2=DGAUSL(CFCT,5)                                                00790005
      Y=DCMPLX (Y1,Y2)                                                  00800000
      RETURN                                                            00810000
      END                                                               00820000
